%{
#include "attribute_types.h"
%}

%{ 
#include <stdio.h>
extern yylex();
 %}

%start S

@attributes { T_VAL val; } S
@attributes { T_Q q; T_VAL val; } L
@attributes { T_VAL val; } B

@traversal print

%%
S : L '.' L
    @{
        @i @S.val@ = @L.0.val@ + @L.1.val@ / @L.1.q@;
        @print {
           /* Print the calculated value to stdout */
           printf("%e\n",@S.val@);
        }
    @}
  ;
L : B
    @{
        @i @L.val@ = @B.val@;
        @i @L.q@=1;
    @}
  | L B
    @{
        @i @L.0.q@ = @L.1.q@ * 2;
        @i @L.0.val@ = @B.val@ + @L.1.val@ * 2;
    @}
  ;
B : '0'
    @{
        @i @B.val@=0;
    @}
  | '1'
    @{
        @i @B.val@=1;
    @}
  ;

%%
 /* start of program */

yyerror(char *s) {
	printf("parser error\n"); exit(2);
}

main () {
	yyparse();
}

